//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Sample
//
//  MODULE:     object_single.cpp
//
//  PURPOSE:    ,  "" .  
//                   
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#include <windows.h>
#include "perf_objects.h"

////////////////////////////////////////////////////////////////////
//
// 
//
////////////////////////////////////////////////////////////////////

//  
//  FUNCTION:     int get_total_length()
//
//  PARAMETERS:   
//
//  RETURN VALUE:    
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:         
//
//  COMMENTS:          ,
//                   
// 
int perf::object_type_single::get_total_length() const
{
	int size = get_definition_length() + get_data_length();

	return size;
}

//////////////////////////////////////////////////////////////
//
//   
//
//////////////////////////////////////////////////////////////

//  
//  FUNCTION:     void write_counter(int, DWORD)
//
//  PARAMETERS:   [IN] i     -  
//                [IN] value - 
//
//  RETURN VALUE: 
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:           
//
//  COMMENTS:        
// 
void perf::object_type_single::write_counter32(int i, int value)
{
	int offset = get_definition_length() + get_counter_data_offset(i);

	write_buffer(offset, &value, sizeof(value));	
}

//  
//  FUNCTION:     void write_counter(int, const LARGE_INTEGER&)
//
//  PARAMETERS:   [IN] i     -  
//                [IN] value - 
//
//  RETURN VALUE: 
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:           
//
//  COMMENTS:        
// 
void perf::object_type_single::write_counter64(int i, __int64 value)
{
	int offset = get_definition_length() + get_counter_data_offset(i);

	write_buffer(offset, &value, sizeof(value));	
}

//  
//  FUNCTION:     void write_counter(int, const void*, int)
//
//  PARAMETERS:   [IN] i     -  
//                [IN] value - 
//                [IN] size  - 
//
//  RETURN VALUE: 
//
//  REVISION:     11.08.2003   
//
//  PURPOSE:           
//
//  COMMENTS:        
// 
void perf::object_type_single::write_counter(int i, const void* value, int size)
{
	int offset = get_definition_length() + get_counter_data_offset(i);

	write_buffer(offset, value, size);	
}

/////////////////////////////////////////////////////////