//
//  Copyright (C) 2003,  . All Rights Reserved.
//
//  PROJECT:    Performance Counter Viewer
//
//  MODULE:     behemothmanager.h
//
//  PURPOSE:    ,       
//
//  AUTHOR(S):   
//
//  PLATFORMS:  Windows NT/2000/XP
//

#ifndef BEHEMOTHMANAGER_H
#define BEHEMOTHMANAGER_H

#include "behemothserver.h"
#include "safearray.h"
#include <vector>

const int Behemoth_man   = 'm';
const int Behemoth_woman = 'w';

class CBehemothManager
{
public:

	CBehemothManager();
	~CBehemothManager();

	// 
	int Connect();

	//  
	int Load();

	//  
	int GetCount() const;

	//      
	const Behemoth* Get() const;

	void Pause();
	void Continue();

	void Create(const TCHAR* name, int sex);
	void Kill(int index);

	bool IsConnected() const {return _loader;}

private:

	CComPtr<IBehemothariumData>    _loader;
	CComPtr<IBehemothariumManager> _manager;

	CComSafeVector<Behemoth> _data;
};

#endif //BEHEMOTHLOADER_H