#ifndef BEHEMOTHTREE_H
#define BEHEMOTHTREE_H

class CBehemothsTree : public CTreeViewCtrl
{
public:
	CBehemothsTree();
	~CBehemothsTree();

	bool Create(HWND parent);
	void Clear();
	
	void Fill(int size, const Behemoth* data);

	int GetCurrentItem();

private:

	bool CreateImageList();
	bool AddBitmap(int id);

	HTREEITEM InsertBehemoth(HTREEITEM hMother, const Behemoth* obj, int param);

	void InsertInt(HTREEITEM parent, const TCHAR* name, int data, int img, int param);
	void InsertDate(HTREEITEM parent, const TCHAR* name, __int64 data, int img, int param);

	HTREEITEM InsertW(HTREEITEM parent, const WCHAR* name, int img, int param);
	HTREEITEM Insert(HTREEITEM parent, const TCHAR* name, int img, int param);
	
private:

	WTL::CImageList _image;
};

#endif //OBJECTSTREE_H