#ifndef CREATEDLG_H
#define CREATEDLG_H

#include "resource.h"

class CCreateDialog : public CDialogImpl<CCreateDialog>
{
public:

	enum {IDD = IDD_CREATE};

	CCreateDialog() {}

	BEGIN_MSG_MAP(CCreateDialog)

		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)

		COMMAND_ID_HANDLER(IDCANCEL,   OnCancel)
		COMMAND_ID_HANDLER(IDOK,       OnOk)

	END_MSG_MAP()

	BOOL OnInitDialog(UINT, WPARAM, LPARAM, BOOL&)
	{
		name.Empty();
		sex = 0;
		CheckRadioButton(IDC_BOY, IDC_GIRL, IDC_BOY);
		return TRUE;
	}

	//  
	LRESULT OnOk(WORD, WORD, HWND, BOOL& b)
	{
		GetString(IDC_NAME, &name);

		if (IsDlgButtonChecked(IDC_BOY) == BST_CHECKED)
		{
			sex = Behemoth_man;
		}
		else
		{
			sex = Behemoth_woman;
		}

		EndDialog(1);
		return 1;
	}

	LRESULT OnCancel(WORD, WORD, HWND, BOOL& b)
	{
		EndDialog(0);
		return 1;
	}

	const TCHAR* get_name() const {return name;}
	int          get_sex()  const {return sex;}

private:

	void GetString(int id, CString* ps)
	{
		ps->Empty();
		
		HWND wnd = GetDlgItem(id);

		if (wnd == NULL)
		{
			return;
		}

		int count = CWindow(wnd).GetWindowTextLength() + 1;

		if (count <= 1)
		{
			return;
		}
				
		CWindow(wnd).GetWindowText(ps->GetBuffer(count), count);
		ps->ReleaseBuffer();
	}

	int sex;
	CString name;
};

#endif //CREATEDLG_H