// Behemotharium_obj.h : Declaration of the CBehemotharium

#ifndef __BEHEMOTHARIUM_H_
#define __BEHEMOTHARIUM_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CBehemotharium
class ATL_NO_VTABLE CBehemothariumObj : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CBehemothariumObj, &CLSID_BehemothariumObj>,
	public IBehemothariumData,
	public IBehemothariumManager
{
public:
	CBehemothariumObj()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_BEHEMOTHARIUM)
DECLARE_NOT_AGGREGATABLE(CBehemothariumObj)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CBehemothariumObj)
	COM_INTERFACE_ENTRY(IBehemothariumData)
	COM_INTERFACE_ENTRY(IBehemothariumManager)
END_COM_MAP()

// IBehemothariumData
public:
	STDMETHOD(Get)(/*[out]*/ SAFEARRAY** psa);
	STDMETHOD(GetSummary)(/*[out]*/ long* count, /*[out]*/ long* weight);


// IBehemothariumManager
public:
	STDMETHOD(Continue)();
	STDMETHOD(Pause)();
	STDMETHOD(Create)(/*[in]*/ BSTR name, /*[in]*/ LONG sex);
	STDMETHOD(Kill)(/*[in]*/ LONG index);
};

#endif //__BEHEMOTHARIUM_H_
