#ifndef BEHEMOTHARIUM_H
#define BEHEMOTHARIUM_H

namespace Behemotharium
{
	struct Behemoth
	{
		enum 
		{
			man = 'm',
			woman = 'w'
		};

		const WCHAR* name;
		int sex;
		int mother;
		int x;
		int y;
		int weight;
		int volume;
		int age;
		__int64 birthday;
	};

	void Start();
	void Stop();

	void Pause();
	void Continue();

	void Lock();
	void Unlock();

	int GetCount();
	int GetWeight();

	void Get(int i, Behemoth* b);

	void Kill(int i);
	void Create(const WCHAR* name, int sex);
}

#endif //BEHEMOTHARIUM_H
